#!/bin/sh
#
# macsat RRDTool script for ASUS WL-500g (Deluxe) v1.1 (18-07-2005)
#
# (c) 2005 by macsat@macsat.com
# Feel free to distribute and improve :-)
# Edited by S$rG 9.12.2008 - 2009
# (c) 2008...
# Edited by dimmer 02.03.2009
# version: beta 10^(-100)
#
# Commands:
#	update_html
#	update_graphs
#	update_graph_daily
#	update_graph_weekly
#	update_graph_monthly
#	update_graph_yearly
#	update_cgi

#  
up_h=update_html
up_g=update_graphs
up_s_g_d=update_graph_daily
up_s_g_w=update_graph_weekly
up_s_g_m=update_graph_monthly
up_s_g_y=update_graph_yearly
up_s_ip=update_graph_ip
up_t_g_d=update_graph_daily_t
up_t_g_w=update_graph_weekly_t
up_t_g_m=update_graph_monthly_t
up_t_g_y=update_graph_yearly_t
up_cpu=update_graph_cpu
up_mem=update_graph_mem
up_cgi=update_cgi

#
D_G="Daily Graphs"
W_G="Weekly Graphs"
M_G="Monthly Graphs"
Y_G="Yearly Graphs"
c_u="CPU usage"
mem_u="Memory usage"
ip_detail="Detail IPs"

c_t_in="in_traffic"	#chain`s for traffic ip
c_t_out="out_traffic"

# Configuration Start 

# Directory for storing RRD Databases
RRDDATA=/opt/traffic

# Directory for storing webpages / images
# and cgi scripts (creating dir "cgi-bin")
RRDIMG=/opt/share/www
cgi="${RRDIMG}"		#dir for cgi
IMG_WWW="" 		#  $cgi

# Name script
script="${RRDDATA}/rrd.sh"
# Name log ip`s
log_ip="${RRDDATA}/ip.list"

# Configuration End

#Output date for log...
date

if [ ! -d "${RRDDATA}" ]
	then
		echo "RRD Database dir: $RRDDATA does not exist...Creating Now...."
		mkdir -p "${RRDDATA}"
fi

if [ ! -d "${RRDIMG}" ]
	then
		echo "RRD Image / web dir: $RRDIMG does not exist....Creating Now...."
		mkdir -p "${RRDIMG}"
		mkdir -p "${cgi}"
fi

if [ ! -f "${log_ip}" ]
then
	echo "" > "${log_ip}"
fi

echo "Create started..."

if [ ! -f "${cgi}/index.cgi" ] || [ "{$1}" = "{$up_cgi}" ]
	then
	echo " cgi script does not exist.....Creating Now...."
	index="${cgi}/index.cgi"
	echo "#!/bin/sh" > "${index}"
	echo 'run_time=`cat /proc/uptime | awk '\''{print $1}'\''`' >> "${index}"
	echo "RRDDATA=$RRDDATA" >> "${index}"
	echo "RRDIMG=$IMG_WWW" >> "${index}"
	echo 'cnt="<center>"' >> "${index}"
	echo 'cnt_end="</center>"' >> "${index}"
	echo 'period=" in this "' >> "${index}"
	echo 'traf="Total traffic"' >> "${index}"
	echo 'speed="Traffic"' >> "${index}"
	echo 'syst="System"' >> "${index}"
	echo 'hlp="Help"' >> "${index}"
	echo 'd="day"' >> "${index}"
	echo 'w="week"' >> "${index}"
	echo 'm="month"' >> "${index}"
	echo 'y="year"' >> "${index}"
	echo 'frame_h=700' >> "${index}"
	echo "up_s_g_d=${up_s_g_d}" >> "${index}"
	echo "up_s_g_w=${up_s_g_w}" >> "${index}"
	echo "up_s_g_m=${up_s_g_m}" >> "${index}"
	echo "up_s_g_y=${up_s_g_y}" >> "${index}"
	echo "up_t_g_d=${up_t_g_d}" >> "${index}"
	echo "up_t_g_w=${up_t_g_w}" >> "${index}"
	echo "up_t_g_m=${up_t_g_m}" >> "${index}"
	echo "up_t_g_y=${up_t_g_y}" >> "${index}"
	echo "up_cpu=${up_cpu}" >> "${index}"
	echo "up_mem=${up_mem}" >> "${index}"
	echo "up_s_ip=${up_s_ip}" >> "${index}"
	echo 'd_g="Daily graphs"' >> "${index}"
	echo 'w_g="Weekly graphs"' >> "${index}"
	echo 'm_g="Monthly graphs"' >> "${index}"
	echo 'y_g="Yearly graphs"' >> "${index}"
	echo 'ip_detail="Detail IPs"' >> "${index}"
	echo "log_ip=$log_ip" >> "${index}"
	echo 'get_ip ()' >> "${index}"
	echo '{' >> "${index}"
	echo 'ip=""' >> "${index}"
	echo 'ip_l=""' >> "${index}"
	echo 'ip_s=`cat "${log_ip}"`' >> "${index}"
	echo 'for ip_v in $ip_s' >> "${index}"
	echo 'do' >> "${index}"
	echo 'a=${ip_v%/*}' >> "${index}"
	echo 'v_a=`echo $a | sed 's/[0-9.]*//'`' >> "${index}"
	echo 'if [ "$v_a" = "" ]' >> "${index}"
	echo 'then' >> "${index}"
	echo 'b=${ip_v#*/}' >> "${index}"
	echo 'v_a=`echo $b | sed 's/[0-9.]*//'`' >> "${index}"
	echo 'if [ "$v_a" = "" ]' >> "${index}"
	echo 'then' >> "${index}"
	echo '[ "$a" = "$b" ] && b="32"' >> "${index}"
	echo '[ "${#b}" -gt 2 ] && b=" $b" || b="/$b"' >> "${index}"
	echo 'c=`ipcalc -nm "$a$b"`' >> "${index}"
	echo 'a=`echo ${c#*NETWORK=} | awk '\''{print $1}'\''`' >> "${index}"
	echo 'b=`echo ${c#*NETMASK=} | awk '\''{print $1}'\''`' >> "${index}"
	echo 'ip_l="$ip_l ""$a"_"$b"' >> "${index}"
	echo 'fi' >> "${index}"
	echo 'fi' >> "${index}"
	echo 'done' >> "${index}"
	echo '}' >> "${index}"
	echo 'if [ "$QUERY_STRING" == "" ]' >> "${index}"
	echo '	then' >> "${index}"
	echo '	QUERY_STRING="sys"' >> "${index}"
	echo 'fi' >> "${index}"
	echo 'case "$QUERY_STRING" in' >> "${index}"
	echo 'sys) vhead="${syst}"' >> "${index}"
	echo '  cnt=""' >> "${index}"
	echo '	cnt_end=""' >> "${index}"
	echo '	tab="`cat /proc/version`<br>`uptime`<br><center>CPU</center><pre>`cat /proc/cpuinfo`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>Memory</center><pre>`cat /proc/meminfo`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>Filesystem</center><pre>`/bin/df -h`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>Proccess</center><pre>`ps`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>Route</center><pre>`route -en`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>ARP</center><pre>`cat /proc/net/arp`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>Hosts</center><pre>`cat /etc/hosts`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>Interfaces</center><pre>`ifconfig`</pre>" ;;' >> "${index}"
	echo 'connect) vhead="${syst}"' >> "${index}"
	echo '  cnt=""' >> "${index}"
	echo '  cnt_end=""' >> "${index}"
	echo '	tab="<center>Listening ports</center><pre>`netstat -l`</pre><br><pre>`netstat -nl`</pre>"' >> "${index}"
	echo '	tab="${tab}<center>Connections</center><pre>`cat /proc/net/ip_conntrack`</pre>" ;;' >> "${index}"
	echo 'iptab) vhead="${syst}"' >> "${index}"
	echo '  cnt=""' >> "${index}"
	echo '  cnt_end=""' >> "${index}"
	echo '	tab="<pre>"`iptables-save`"</pre>" ;;' >> "${index}"
	echo 's_g_d) vhead=${speed}${period}${d}' >> "${index}"
	echo '	UPG=${up_s_g_d}' >> "${index}"
	echo '	graph1="wan${d}"' >> "${index}"
	echo '	graph2="lan${d}"' >> "${index}"
	echo '  graph3="wlan${d}" ;;' >> "${index}"
	echo 's_g_w) vhead=${speed}${period}${w}' >> "${index}"
	echo '  UPG=${up_s_g_w}' >> "${index}"
	echo '  graph1="wan${w}"' >> "${index}"
	echo '  graph2="lan${w}"' >> "${index}"
	echo '  graph3="wlan${w}" ;;' >> "${index}"
	echo 's_g_m) vhead=${speed}${period}${m}' >> "${index}"
	echo '  UPG=${up_s_g_m}' >> "${index}"
	echo '  graph1="wan${m}"' >> "${index}"
	echo '  graph2="lan${m}"' >> "${index}"
	echo '  graph3="wlan${m}" ;;' >> "${index}"
	echo 's_g_y) vhead=${speed}${period}${y}' >> "${index}"
	echo '  UPG=${up_s_g_y}' >> "${index}"
	echo '  graph1="wan${y}"' >> "${index}"
	echo '  graph2="lan${y}"' >> "${index}"
	echo '  graph3="wlan${y}" ;;' >> "${index}"
	echo 's_g_ip) vhead="${ip_detail}"' >> "${index}"
	echo '	UPG="${up_s_ip}"' >> "${index}"
	echo '	 tab=""' >> "${index}"
	echo '	get_ip' >> "${index}"
	echo '	 for ip_v in $ip_l' >> "${index}"
	echo '	do' >> "${index}"
	echo '	 tab="${tab}<img src=$RRDIMG/${ip_v}_d.png><img src=$RRDIMG/${ip_v}_w.png><img src=$RRDIMG/${ip_v}_m.png><img src=$RRDIMG/${ip_v}_y.png><br><br>"' >> "${index}"
	echo '	 done ;;' >> "${index}"
	echo 't_g_d) vhead=${traf}${period}${d}' >> "${index}"
	echo '	UPG="${up_t_g_d}"' >> "${index}"
	echo '  graph1="twan${d}"' >> "${index}"
	echo '  graph2="tlan${d}"' >> "${index}"
	echo '  graph3="twlan${d}" ;;' >> "${index}"
	echo 't_g_w) vhead=${traf}${period}${w}' >> "${index}"
	echo '	UPG="${up_t_g_w}"' >> "${index}"
	echo '  graph1="twan${w}"' >> "${index}"
	echo '  graph2="tlan${w}"' >> "${index}"
	echo '  graph3="twlan${w}" ;;' >> "${index}"
	echo 't_g_m) vhead=${traf}${period}${m}' >> "${index}"
	echo '	UPG="${up_t_g_m}"' >> "${index}"
	echo '  graph1="twan${m}"' >> "${index}"
	echo '  graph2="tlan${m}"' >> "${index}"
	echo '  graph3="twlan${m}" ;;' >> "${index}"
	echo 't_g_y) vhead=${traf}${period}${y}' >> "${index}"
	echo '	UPG="${up_t_g_y}"' >> "${index}"
	echo '  graph1="twan${y}"' >> "${index}"
	echo '  graph2="tlan${y}"' >> "${index}"
	echo '  graph3="twlan${y}" ;;' >> "${index}"
	echo 'cpu_mem) vhead="CPU & Memory usage"' >> "${index}"
	echo '	UPG="${up_cpu}"' >> "${index}"
	echo '	tab="<img src=$RRDIMG/cpu.png><br><img src=$RRDIMG/mem.png>" ;;' >> "${index}"
	echo 'help) vhead="${hlp}"' >> "${index}"
	echo '	cnt=""' >> "${index}"
	echo '	cnt_end=""' >> "${index}"
	echo '	tab="<iframe height=$frame_h width=100% src="http://busybox.net/downloads/BusyBox.html"></iframe>" ;;' >> "${index}"
	echo 'help1) vhead="${hlp}"' >> "${index}"
	echo '  cnt=""' >> "${index}"
	echo '  cnt_end=""' >> "${index}"
	echo '  tab="<iframe height=$frame_h width=100% src="http://wl500g.info/forumdisplay.php?f=86"></iframe>" ;;' >> "${index}"
	echo 'help2) vhead="${hlp}"' >> "${index}"
	echo '  cnt=""' >> "${index}"
	echo '  cnt_end=""' >> "${index}"
	echo '  tab="<iframe height=$frame_h width=100% src="http://oss.oetiker.ch/rrdtool/"></iframe>" ;;' >> "${index}"
	echo '*) vhead="${syst}"' >> "${index}"
	echo '	tab="Hi!" ;;' >> "${index}"
	echo 'esac' >> "${index}"
	echo 'if [ "$tab" == "" ] & [ "$graph3" != "" ]' >> "${index}"
	echo '	then' >> "${index}"
	echo '	tab="<img src=$RRDIMG/${graph1}.png><br><img src=$RRDIMG/${graph2}.png><br><img src=$RRDIMG/${graph3}.png>"' >> "${index}"
	echo 'fi' >> "${index}"
	echo 'echo "Content-type: text/html; charset=utf-8"' >> "${index}"
	echo 'echo '  >> "${index}"
	echo 'echo "<HTML><HEAD><TITLE>System & Traffic</TITLE><meta http-equiv="pragma" content="no-cache">"' >> "${index}"
	echo 'echo "<meta http-equiv="PRAGMA" content="no-cache, no-store,  must-revalidate">"' >> "${index}"
	echo 'echo "<meta HTTP-EQUIV="EXPIRES" CONTENT="Mon, 01 Jul 1970 01:01:01 GMT">"' >> "${index}"
	echo 'echo "</HEAD><BODY><center>"' >> "${index}"
	echo 'echo "<table cols=2 width=100% border=0>"' >> "${index}"
	echo 'echo "<tr><td><center><h3>${vhead}</h3></center></td>"' >> "${index}"
	echo 'echo "<td width=50><center><p><a href="update.cgi?$UPG"> Update data </a></p>"' >> "${index}"
	echo 'echo "</center></td></tr></table>"' >> "${index}"
	echo 'echo "<table width="100%" border="0"><tr><td valign="top">"' >> "${index}"
	echo 'echo "<fieldset><legent>"${syst}:"</legent><br><a href='index.cgi?sys'>"${syst} status"</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?cpu_mem'>CPU & Memory</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?connect'>Connections & ports</a>"' >> "${index}"
	echo 'echo "<a href='index.cgi?iptab'>iptables</a>"' >> "${index}"
	echo 'echo "</fieldset>"' >> "${index}"
	echo 'echo "<fieldset><legent>Interfaces loads:</legent><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?s_g_d'>"$d_g"</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?s_g_w'>"$w_g"</a><br><a href='index.cgi?s_g_m'> "$m_g" </a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?s_g_y'>"$y_g"</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?s_g_ip'>"${ip_detail}"</a></fieldset>"' >> "${index}"
	echo 'echo "<fieldset><legent>Total traffic:</legent><br><a href='index.cgi?t_g_d'>"$d_g"</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?t_g_w'>"$w_g"</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?t_g_m'>"$m_g"</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?t_g_y'>"$y_g"</a><br>"' >> "${index}"
	echo 'echo "</fieldset>"' >> "${index}"
	echo 'echo "<fieldset><legent>"${hlp}:"</legent><br><a href='index.cgi?help'>Busybox</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?help1'>"wl500g.info"</a><br>"' >> "${index}"
	echo 'echo "<a href='index.cgi?help2'>"RRDtool"</a></fieldset></td>"' >> "${index}"
	echo 'echo "<td width=85%>${cnt} ${tab} ${cnt_end}</td></table>"' >> "${index}"
	echo 'run_time2=`cat /proc/uptime | awk '\''{print $1}'\''`' >> "${index}"
	echo 'run_time=`echo "$run_time2 $run_time" | awk '\''{printf "%s\n",$1-$2}'\''`' >> "${index}"
	echo 'echo "${run_time} sec."' >> "${index}"
	echo 'echo "</BODY></HTML>"' >> "${index}"
	chmod +x "${index}"
fi

if [ ! -f "${cgi}/update.cgi" ] || [ "{$1}" = "{$up_cgi}" ]
	then
	echo " cgi script does not exist.....Creating Now...."
	echo "#!/bin/sh" > "${cgi}/update.cgi"
	echo "rrd_path=$script" >> "${cgi}/update.cgi"
	echo 'echo "Content-type: text/html; charset=utf-8"' >> "${cgi}/update.cgi"
	echo "echo "  >> "${cgi}/update.cgi"
	echo 'echo "<html><title>Update</title>"' >> "${cgi}/update.cgi"
	echo 'if [ "$QUERY_STRING" != "" ]' >> "${cgi}/update.cgi"
	echo 'then' >> "${cgi}/update.cgi"
	echo 'echo "Start update..<br>"' >> "${cgi}/update.cgi"
	echo '$rrd_path $QUERY_STRING &' >> "${cgi}/update.cgi"
	echo 'wait' >> "${cgi}/update.cgi"
	echo 'else' >> "${cgi}/update.cgi"
	echo 'echo "Nothing update!"' >> "${cgi}/update.cgi"
	echo 'fi' >> "${cgi}/update.cgi"
	echo 'echo "<br><a href=$HTTP_REFERER>Go back</a></html>"'  >> "${cgi}/update.cgi"
	chmod +x "${cgi}/update.cgi"
fi


WANIF=`nvram get wan_ifname`
LANIF=`nvram get lan_ifnames | awk '{print $1}'`
WLANIF=`nvram get wl0_ifname`

#debug lines
echo "WAN Interface: ${WANIF}"
echo "LAN Interface: ${LANIF}"
echo "WLAN Interface: ${WLANIF}"


WANRRD="${RRDDATA}/${WANIF}.rrd"
LANRRD="${RRDDATA}/${LANIF}.rrd"
WLANRRD="${RRDDATA}/${WLANIF}.rrd"
CPU_D="${RRDDATA}/cpu.rrd"
MEM_D="${RRDDATA}/mem.rrd"

CreateRRD ()
{	
	#rrdtool create "${1}" \
	#DS:in:DERIVE:600:0:U \
	#DS:out:DERIVE:600:0:U \
	#RRA:AVERAGE:0.5:1:576 \
	#RRA:AVERAGE:0.5:6:672 \
	#RRA:AVERAGE:0.5:24:744 \
	#RRA:AVERAGE:0.5:144:1464
	rrdtool create "${1}" \
	DS:in:DERIVE:600:0:U \
	DS:out:DERIVE:600:0:U \
	RRA:AVERAGE:0.5:1:2018 \
	RRA:AVERAGE:0.5:4:2232 \
	RRA:AVERAGE:0.5:12:8784

}

CreateRRD_CPU ()
{	
	rrdtool create "${1}" \
	DS:usr:COUNTER:600:0:U \
	DS:sys:COUNTER:600:0:U \
	DS:nice:COUNTER:600:0:U \
	DS:idle:COUNTER:600:0:U \
	RRA:AVERAGE:0.5:1:576
}

CreateRRD_Mem ()
{	
	rrdtool create "${1}" \
	DS:used:GAUGE:600:0:U \
	DS:free:GAUGE:600:0:U \
	DS:buff:GAUGE:600:0:U \
	DS:cache:GAUGE:600:0:U \
	DS:swap_free:GAUGE:600:0:U \
	RRA:AVERAGE:0.5:1:576
}

if [ ! -f "${WANRRD}" ]
	then
		echo "RRD file : ${WANRRD} does not exist...Creating Now..."
		CreateRRD "${WANRRD}"
fi

if [ ! -f "${LANRRD}" ]
        then
                echo "RRD file : ${LANRRD} does not exist...Creating Now..."
		CreateRRD "${LANRRD}"
fi

if [ ! -f "${WLANRRD}" ]
        then
                echo "RRD file : ${WLANRRD} does not exist...Creating Now..."
		CreateRRD "${WLANRRD}"
fi

if [ ! -f "${CPU_D}" ]
        then
                echo "RRD file : ${CPU_D} does not exist...Creating Now..."
		CreateRRD_CPU "${CPU_D}"
fi

if [ ! -f "${MEM_D}" ]
        then
                echo "RRD file : ${MEM_D} does not exist...Creating Now..."
		CreateRRD_Mem "${MEM_D}"
fi

#3-  ip_s -    ,ip - [ip]/[mask]  ip_l -  .rrd
get_ip ()
{
ip=""
ip_l=""
ip_s=`cat "${log_ip}"`
for ip_ in $ip_s
do
	a=${ip_%/*}
	v_a=`echo $a | sed 's/[0-9.]*//'`
	if [ "$v_a" = "" ]
	then
		b=${ip_#*/}
		v_a=`echo $b | sed 's/[0-9.]*//g'`
		if [ "$v_a" = "" ]
			then
			[ "$a" = "$b" ] && b='32'
			[ "${#b}" -gt 2 ] && b=" $b" || b="/$b"
			c=`ipcalc -nm "$a$b"`
			a=`echo ${c#*NETWORK=} | awk '{print $1}'`
			b=`echo ${c#*NETMASK=} | awk '{print $1}'`
			ip_l="$ip_l ""$a"_"$b"
			[ "$b" = "255.255.255.255" ] && ip="$ip $a" || ip="$ip $a/$b"
		fi
	fi
done
}

if [ "$1" = "" ]
then
WANIN=`ifconfig "${WANIF}" |grep bytes|awk -F ":" '{print $2}'|awk '{print $1}'`
WANOUT=`ifconfig "${WANIF}" |grep bytes|awk -F ":" '{print $3}'|awk '{print $1}'`
LANOUT=`ifconfig "${LANIF}" |grep bytes|awk -F ":" '{print $2}'|awk '{print $1}'`
LANIN=`ifconfig "${LANIF}" |grep bytes|awk -F ":" '{print $3}'|awk '{print $1}'`
WLANOUT=`ifconfig "${WLANIF}" |grep bytes|awk -F ":" '{print $2}'|awk '{print $1}'`
WLANIN=`ifconfig "${WLANIF}" |grep bytes|awk -F ":" '{print $3}'|awk '{print $1}'`
# Update the Databases
`rrdupdate "${WANRRD}" -t in:out N:"${WANIN}":"${WANOUT}"`
`rrdupdate "${LANRRD}" -t in:out N:"${LANIN}":"${LANOUT}"`
`rrdupdate "${WLANRRD}" -t in:out N:"${WLANIN}":"${WLANOUT}"`

# Debug
echo "WAN -> in: ${WANIN}   out: ${WANOUT} "
echo "LAN -> in: ${LANIN}   out: ${LANOUT}"
echo "WLAN -> in: ${WLANIN}   out: ${WLANOUT}"

read CPU cpu_usr cpu_nice cpu_sys cpu_idle < /proc/stat
v_mem=`cat /proc/meminfo | grep Mem:`
mem_u=`echo "$v_mem" | awk '{print $3}'`
mem_f=`echo "$v_mem" | awk '{print $4}'`
mem_b=`echo "$v_mem" | awk '{print $6}'`
mem_c=`echo "$v_mem" | awk '{print $7}'`
mem_s=`cat /proc/meminfo | grep SwapTotal: | awk '{print $2*1024}'`
`rrdupdate "${CPU_D}" -t usr:sys:nice:idle N:"${cpu_usr}":"${cpu_sys}":"${cpu_nice}":"${cpu_idle}"`
`rrdupdate "${MEM_D}" -t used:free:buff:cache:swap_free N:"${mem_u}":"${mem_f}":"${mem_b}":"${mem_c}":"${mem_s}"`

get_ip
#Create chain`s
WLINT=`nvram get lan_ifname`
a=`iptables-save | grep ":$c_t_in"`
if [ "$a" = '' ]
	then
	`iptables -N "$c_t_in"`
	`iptables -I FORWARD 2 -o "$WLINT" -j "$c_t_in"`
fi
a=`iptables-save | grep ":$c_t_out"`
if [ "$a" = '' ]
	then
	`iptables -N "$c_t_out"`
	`iptables -I FORWARD 2 -i "$WLINT" -j "$c_t_out"`
fi
i=2
for ip_v in $ip
do
	a=`echo "$i ${ip_l}" | awk '{print $($1)}'`
	if [ ! -f "${RRDDATA}/${a}.rrd" ]
		then
		CreateRRD "${RRDDATA}/${a}.rrd"
	fi
	b=`iptables-save | grep "A $c_t_in -d "$ip_v"`
	if [ "$b" = '' ]
		then
		iptables -A "$c_t_in" -d "$ip_v"
		iptables -A "$c_t_out" -s "$ip_v"
	fi
	b=`echo $ip_v | grep /`
	if [ "$b" != "" ]
	then
		b=`echo $ip_v | sed 's/\// /'`
		b=`ipcalc -p "$b"`
		b=`echo ${b#*PREFIX=}`
		ip_v=`echo $ip_v | sed "s/\/[0-9.]*/\/$b/"`
	fi
	c=`iptables -L "$c_t_in" -nvx | grep "$ip_v" | awk '{print $2}'`
	d=`iptables -L "$c_t_out" -nvx | grep "$ip_v" | awk '{print $2}'`
	`rrdupdate "${RRDDATA}/${a}.rrd" -t in:out N:"$c":"$d"`
	i=$(($i+1))
done
fi

# $1 = ImageFile , $2 = Time in secs to go back , $3 = RRDfil , $4 = GraphText
CreateGraph ()
{
  /opt/bin/rrdtool graph "${1}.new" -a PNG -R light -s -"${2}" -w 550 -h 240 -v "bytes/s" -r -l 0 \
  'DEF:ds1='${3}':in:AVERAGE' \
  'DEF:ds2='${3}':out:AVERAGE' \
  'AREA:ds1#00FF00:Incoming Traffic' \
  GPRINT:ds1:MAX:"Max %6.2lf %s" \
  GPRINT:ds1:MIN:"Min %6.2lf %s" \
  GPRINT:ds1:AVERAGE:"Avg %6.2lf %s" \
  GPRINT:ds1:LAST:"Curr %6.2lf %s\n" \
  'LINE1:ds2#0000FF:Outgoing Traffic' \
  GPRINT:ds2:MAX:"Max %6.2lf %s" \
  GPRINT:ds2:MIN:"Min %6.2lf %s" \
  GPRINT:ds2:AVERAGE:"Avg %6.2lf %s" \
  GPRINT:ds2:LAST:"Curr %6.2lf %s" \
  -t "${4}"
  mv -f "${1}.new" "${1}"
}

# $1 = ImageFile , $2 = Time in secs to go back , $3 = RRDfil , $4 = GraphText
CreateGraphTotal ()
{
	/opt/bin/rrdtool graph "${1}.new" -a PNG -R light -s -"${2}" -w 550 -h 240 -v "bytes" -r -l 0 \
	'DEF:d1='"$3"':in:AVERAGE' \
	'DEF:d2='"$3"':out:AVERAGE' \
	'CDEF:t_in=d1,300,*' \
	'CDEF:t_out=d2,300,*' \
	'VDEF:sum_in=d1,TOTAL' \
	'VDEF:sum_out=d2,TOTAL' \
	'AREA:t_in#00FF00:Incoming Traffic (5 min)' \
	GPRINT:sum_in:"Total %lf%s \n" \
	'LINE1:t_out#0000FF:Outgoing Traffic (5 min)' \
	GPRINT:sum_out:"Total %lf%s" \
	-t "${4}"
	mv -f "${1}.new" "${1}"
}

# $1 = ImageFile , $2 = Time in secs to go back , $3 = RRDfil , $4 = GraphText
CreateGraphIP ()
{
	/opt/bin/rrdtool graph "${1}.new" -a PNG -R light -s -"${2}" -w 410 -h 100 -v "bytes/s" -l 0 --font DEFAULT:7 \
	'DEF:ds1='${3}':in:AVERAGE' \
	'DEF:ds2='${3}':out:AVERAGE' \
	'VDEF:sum_in=ds1,TOTAL' \
	'VDEF:sum_out=ds2,TOTAL' \
	'AREA:ds1#00FF00:In' \
	GPRINT:ds1:MAX:"Max %6.2lf%s" \
	GPRINT:ds1:MIN:"Min %6.2lf%s" \
	GPRINT:ds1:AVERAGE:"Avg %6.2lf%s" \
	GPRINT:ds1:LAST:"Cur %6.2lf%s" \
	GPRINT:sum_in:"Total %6.2lf%s\n" \
	'LINE1:ds2#0000FF:Out' \
	GPRINT:ds2:MAX:"Max %6.2lf%s" \
	GPRINT:ds2:MIN:"Min %6.2lf%s" \
	GPRINT:ds2:AVERAGE:"Avg %6.2lf%s" \
	GPRINT:ds2:LAST:"Cur %6.2lf%s" \
	GPRINT:sum_out:"Total %6.2lf%s" \
	-t "${4}"
	mv -f "${1}.new" "${1}"
}

# Set time-variables
MTIME=`date "+%M"`
HTIME=`date "+%H"`
DTIME=`date "+%u"`
dmTIME=`date "+%e"`
dyTIME=`date "+%j"`
stime="generated - `date`"

# Update Daily graphs every 30 mins 
if [ "{$1}" = "{$up_s_g_d}" ] || [ "{$1}" = "{$up_g}" ];
then
# 1 Day Graph
echo "$D_G created....."
CreateGraph "${RRDIMG}/wanday.png" 86400 "${WANRRD}" "WAN $stime"
CreateGraph "${RRDIMG}/landay.png" 86400 "${LANRRD}" "LAN $stime"
CreateGraph "${RRDIMG}/wlanday.png" 86400 "${WLANRRD}" "WLAN $stime"
fi

# Update Weekly graph once a day
if [ "{$1}" = "{$up_s_g_w}" ] || [ "{$1}" = "{$up_g}" ];
then
# 1 Week Graph
echo "$W_G created....."
CreateGraph "${RRDIMG}/wanweek.png" 604800 "${WANRRD}" "WAN $stime"
CreateGraph "${RRDIMG}/lanweek.png" 604800 "${LANRRD}" "LAN $stime"
CreateGraph "${RRDIMG}/wlanweek.png" 604800 "${WLANRRD}" "WLAN $stime"
fi

# Update  Monthly graphs once a day (maby twice a day on 12h settings)
if [ "{$1}" = "{$up_s_g_m}" ] || [ "{$1}" = "{$up_g}" ];
then
# 1 Month Graph
echo "$M_G Created...."
CreateGraph "${RRDIMG}/wanmonth.png" 2678400 "${WANRRD}" "WAN $stime"
CreateGraph "${RRDIMG}/lanmonth.png" 2678400 "${LANRRD}" "LAN $stime"
CreateGraph "${RRDIMG}/wlanmonth.png" 2678400 "${WLANRRD}" "WLAN $stime"
fi

# Update Yearly graphs
# 1 Year Graph
if [ "{$1}" = "{$up_s_g_y}" ] || [ "{$1}" = "{$up_g}" ];
then
echo "$Y_G Created...."
CreateGraph "${RRDIMG}/wanyear.png" 31536000 "${WANRRD}" "WAN $stime"
CreateGraph "${RRDIMG}/lanyear.png" 31536000 "${LANRRD}" "LAN $stime"
CreateGraph "${RRDIMG}/wlanyear.png" 31536000 "${WLANRRD}" "WLAN $stime"
fi

if [ "$1" = "$up_t_g_d" ] || [ "$1" = "$up_g" ];
then
	echo "$D_G created....."
	st=`echo "$HTIME $MTIME" | awk '{print ($1*60+$2)*60}'`	#$((($HTIME*60+$MTIME)*60))
	CreateGraphTotal "${RRDIMG}/twanday.png" "$st" "${WANRRD}" "WAN $stime"
	CreateGraphTotal "${RRDIMG}/tlanday.png" "$st" "${LANRRD}" "LAN $stime"
	CreateGraphTotal "${RRDIMG}/twlanday.png" "$st" "${WLANRRD}" "WLAN $stime"
fi

if [ "{$1}" = "{$up_t_g_w}" ] || [ "{$1}" = "{$up_g}" ];
then
	echo "$W_G created....."
	st=`echo "$HTIME $MTIME $DTIME" | awk '{print $3*24*3600+($1*60+$2)*60}'`
	CreateGraphTotal "${RRDIMG}/twanweek.png" "$st" "${WANRRD}" "WAN $stime"
	CreateGraphTotal "${RRDIMG}/tlanweek.png" "$st" "${LANRRD}" "LAN $stime"
	CreateGraphTotal "${RRDIMG}/twlanweek.png" "$st" "${WLANRRD}" "WLAN $stime"
fi

if [ "{$1}" = "{$up_t_g_m}" ] || [ "{$1}" = "{$up_g}" ];
then
	echo "$M_G created....."
	st=`echo "$HTIME $MTIME $dmTIME" | awk '{print ($3-1)*24*3600+($1*60+$2)*60}'`
	CreateGraphTotal "${RRDIMG}/twanmonth.png" "$st" "${WANRRD}" "WAN $stime"
	CreateGraphTotal "${RRDIMG}/tlanmonth.png" "$st" "${LANRRD}" "LAN $stime"
	CreateGraphTotal "${RRDIMG}/twlanmonth.png" "$st" "${WLANRRD}" "WLAN $stime"
fi

if [ "{$1}" = "{$up_t_g_y}" ] || [ "{$1}" = "{$up_g}" ];
then
	echo "$Y_G created....."
	st=`echo "$HTIME $MTIME $dyTIME" | awk '{print ($3-1)*24*3600+($1*60+$2)*60}'`
	CreateGraphTotal "${RRDIMG}/twanyear.png" "$st" "${WANRRD}" "WAN $stime"
	CreateGraphTotal "${RRDIMG}/tlanyear.png" "$st" "${LANRRD}" "LAN $stime"
	CreateGraphTotal "${RRDIMG}/twlanyear.png" "$st" "${WLANRRD}" "WLAN $stime"
fi

if [ "{$1}" = "{$up_cpu}" ] || [ "{$1}" = "{$up_g}" ];
then
	echo "$c_u created....."
	/opt/bin/rrdtool graph "${RRDIMG}/cpu.png.new" -a PNG -R light -s -86400 -w 550 -h 240  -v "%" -r \
	'DEF:d1='"$CPU_D"':usr:AVERAGE' \
	'DEF:d2='"$CPU_D"':sys:AVERAGE' \
	'DEF:d3='"$CPU_D"':nice:AVERAGE' \
	'DEF:d4='"$CPU_D"':idle:AVERAGE' \
	'CDEF:d_u=100,d1,d1,d2,d3,d4,+,+,+,/,*' \
	'CDEF:d_s=100,d2,d1,d2,d3,d4,+,+,+,/,*' \
	'CDEF:d_n=100,d3,d1,d2,d3,d4,+,+,+,/,*' \
	'CDEF:d_i=100,d4,d1,d2,d3,d4,+,+,+,/,*' \
	'CDEF:d_t=d_u,d_s,d_n,+,+' \
	'AREA:d_u#00FF00:User  ' \
	GPRINT:d_u:MIN:"Min %6.2lf %s" \
	GPRINT:d_u:MAX:"Max %6.2lf %s" \
	'VDEF:av=d_u,AVERAGE' \
	GPRINT:av:"Aver %6.2lf %s" \
	GPRINT:d_u:LAST:"Curr %6.2lf %s \n" \
	'STACK:d_s#0000FF:System' \
	GPRINT:d_s:MIN:"Min %6.2lf %s" \
	GPRINT:d_s:MAX:"Max %6.2lf %s" \
	'VDEF:av1=d_s,AVERAGE' \
	GPRINT:av1:"Aver %6.2lf %s" \
	GPRINT:d_s:LAST:"Curr %6.2lf %s \n" \
	'STACK:d_n#FFAA00:Nice' \
	GPRINT:d_n:MIN:"Min %6.2lf %s" \
	GPRINT:d_n:MAX:"Max %6.2lf %s" \
	'VDEF:av2=d_n,AVERAGE' \
	GPRINT:av2:"Aver %6.2lf %s" \
	GPRINT:d_n:LAST:"Curr %6.2lf %s \n" \
	'STACK:d_i#FFFFFF:Idle' \
	GPRINT:d_i:MIN:"Min (idle) %6.2lf %s" \
	GPRINT:d_i:MAX:"Max (idle) %6.2lf %s" \
	'VDEF:av3=d_i,AVERAGE' \
	GPRINT:av3:"Aver %6.2lf %s" \
	GPRINT:d_i:LAST:"Curr %6.2lf %s \n" \
	'LINE1:d_t#F000F0:"Total utilization"' \
	GPRINT:d_t:MIN:"Min %6.2lf %s" \
	GPRINT:d_t:MAX:"Max %6.2lf %s" \
	'VDEF:av4=d_t,AVERAGE' \
	GPRINT:av4:"Aver %6.2lf %s" \
	GPRINT:d_t:LAST:"Curr %6.2lf %s \n" \
	'HRULE:100#00AAFF:"Maximum allowed"' \
	-t "CPU utilization, $stime"
	mv -f "${RRDIMG}/cpu.png.new" "${RRDIMG}/cpu.png"

	echo "$mem_u created....."
	/opt/bin/rrdtool graph "${RRDIMG}/mem.png.new" -a PNG -R light -s -86400 -w 550 -h 240  -v "bytes" -b 1024 -r -l 0 \
	'DEF:d1='"$MEM_D"':used:AVERAGE' \
	'DEF:d2='"$MEM_D"':free:AVERAGE' \
	'DEF:d3='"$MEM_D"':buff:AVERAGE' \
	'DEF:d4='"$MEM_D"':cache:AVERAGE' \
	'DEF:d5='"$MEM_D"':swap_free:AVERAGE' \
	'AREA:d2#00FF00:Free' \
	GPRINT:d2:MIN:"Min %6.2lf %s" \
	GPRINT:d2:MAX:"Max %6.2lf %s" \
	'VDEF:av=d2,AVERAGE' \
	GPRINT:av:"Aver %6.2lf %s" \
	GPRINT:d2:LAST:"Cur %6.2lf %s \n" \
	'STACK:d1#0000FF:Used' \
	GPRINT:d1:MIN:"Min %6.2lf %s" \
	GPRINT:d1:MAX:"Max %6.2lf %s" \
	'VDEF:av1=d1,AVERAGE' \
	GPRINT:av1:"Aver %6.2lf %s" \
	GPRINT:d1:LAST:"Cur %6.2lf %s \n" \
	'STACK:d3#FFAA00:Buffer' \
	GPRINT:d3:MIN:"Min %6.2lf %s" \
	GPRINT:d3:MAX:"Max %6.2lf %s" \
	'VDEF:av2=d3,AVERAGE' \
	GPRINT:av2:"Aver %6.2lf %s" \
	GPRINT:d3:LAST:"Cur %6.2lf %s \n" \
	'STACK:d4#F000F0:Cache:' \
	GPRINT:d4:MIN:"Min %6.2lf %s" \
	GPRINT:d4:MAX:"Max %6.2lf %s" \
	'VDEF:av3=d4,AVERAGE' \
	GPRINT:av3:"Aver %6.2lf %s" \
	GPRINT:d4:LAST:"Cur %6.2lf %s \n" \
	'LINE1:d5#00AAFF:"Free swap"' \
	GPRINT:d5:MIN:"Min %6.2lf %s" \
	GPRINT:d5:MAX:"Max %6.2lf %s" \
	'VDEF:av4=d5,AVERAGE' \
	GPRINT:av4:"Aver %6.2lf %s" \
	GPRINT:d5:LAST:"Cur %6.2lf %s \n" \
	-t "Memory utilization, $stime"
	mv -f "${RRDIMG}/mem.png.new" "${RRDIMG}/mem.png"
fi

if [ "{$1}" = "{$up_s_ip}" ] || [ "{$1}" = "{$up_g}" ];
then
	echo "IPs graphs created....."
	get_ip
	i=2
	for ip_v in $ip_l
	do
		a=`echo "$i ${ip}" | awk '{print $($1)}' #| sed 's/\// /'`
		st=`echo "$HTIME $MTIME" | awk '{print ($1*60+$2)*60}'`
		CreateGraphIP "${RRDIMG}/${ip_v}_d.png" "$st" "${RRDDATA}/${ip_v}.rrd" "$D_G $a, $stime"
		st_=`echo "$DTIME $st" | awk '{print $1*24*3600+$2}'`
		CreateGraphIP "${RRDIMG}/${ip_v}_w.png" "$st_" "${RRDDATA}/${ip_v}.rrd" "$W_G $a, $stime"
		st_=`echo "$dmTIME $st" | awk '{print ($1-1)*24*3600+$2}'`
		CreateGraphIP "${RRDIMG}/${ip_v}_m.png" "$st_" "${RRDDATA}/${ip_v}.rrd" "$M_G $a, $stime"
		st_=`echo "$dyTIME $st" | awk '{print ($1-1)*24*3600+$2}'`
		CreateGraphIP "${RRDIMG}/${ip_v}_y.png" "$st_" "${RRDDATA}/${ip_v}.rrd" "$Y_G $a, $stime"
		i=$(($i+1))
	done
fi

echo " <------------------------------------------------------------->"
echo " "
